1. 程式人生 > >在C#中用COM操作CAD

在C#中用COM操作CAD

time ops pac too lin 版本 adt lisp cad

一、介紹

AutoCAD的二次開發形式非常多, 有Autolisp,ObjectARX,VBA等,在本章我給大家介紹的是不太常用的COM方式操作CAD。

使用COM的方式有前期綁定和後期綁定2種。

二、示例代碼

1、前期綁定

 1 namespace ConsoleApplication2
 2 {
 3     class Program
 4     {
 5         static void Main(string[] args)
 6         {
 7             Autodesk.AutoCAD.Interop.AcadApplication app = new
Autodesk.AutoCAD.Interop.AcadApplication(); 8 app.Visible = true; 9 AcadDocument doc = app.ActiveDocument; 10 double []spoint = {0,0,0}; 11 double []epoint = { 0, 1000, 0 }; 12 doc.ModelSpace.AddLine(spoint,epoint); 13 app.ZoomAll();
14 15      //添加工具欄 16 AcadToolbar tool = app.MenuGroups.Item(0).Toolbars.Add("test toolbar group"); 17 AcadToolbarItem tbaritem = tool.AddToolbarButton(0, "mycommand1","new line","L " ,false); 18 tbaritem.SetBitmaps("Small iconname ", "Big iconname "); 19 Console.ReadLine();
20 } 21 } 22 }

2、後期綁定

 1 using System;
 2 using System.Collections.Generic;
 3 using System.Text;
 4 using System.Runtime.InteropServices;
 5 using Autodesk.AutoCAD.Interop;
 6 
 7 
 8 namespace ConsoleApplication2
 9 {
10     class Program
11     {
12         static void Main(string[] args)
13         {
14             try
15             {
16                 AcadApplication app = (AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.17");
17                 AcadDocument doc = app.ActiveDocument;
18                 double[] spoint = { 0, 0, 0 };
19                 double[] epoint = { 0, 1000, 0 };
20                 doc.ModelSpace.AddLine(spoint, epoint);
21                 app.ZoomAll();
22                 AcadToolbar tool = app.MenuGroups.Item(0).Toolbars.Add("test");
23                 AcadToolbarItem tbaritem = tool.AddToolbarButton(0, "mycommand1", "new line", "L ", false);
24                 tbaritem.SetBitmaps("Small iconname ", "Big iconname ");
25                 Console.ReadLine();
26             }
27             catch
28             {
29 
30             }
31             
32         }
}

三、總結

在使用前期綁定速度快於後期綁定,但後期綁定的好處是在未知目標機器上CAD的版本情況下可以指定多個不同的版本。

在C#中用COM操作CAD